/* Copyright (C) 2002 / 2003 AFE-GmdG */

#ifndef _GAMELOOPDEMO_H // Prfe, ob dieser Header nicht schon andersweitig eingebunden wurde
#define _GAMELOOPDEMO_H

/* Standard Windows Header */
#include <windows.h>
#include <process.h>
#include <tchar.h>

/* Header, die von GameLoopDemo.cpp bentigt werden */
#include "Input.h"

/* Die Klasse GameLoopDemo */
class CGameLoopDemo {
private:
  HINSTANCE m_hInstance;
  HWND m_hWnd;
  CInput *m_lpInput;
  HANDLE m_hRunMutex;
  HANDLE m_hRenderMutex;
  HANDLE m_hInputMutex;
  BOOL m_ExitFail;
  BOOL m_ExitOK;

  HWND CreateMainWindow();

public:
  CGameLoopDemo(void);
  virtual ~CGameLoopDemo(void);

  BOOL Init(HINSTANCE hInstance);
  BOOL Run();
  BOOL Done();
  DWORD Render();
  HANDLE GetInputMutex();
  HANDLE GetRunMutex();
};

/* Klassenunabhngige Funktionen, die ich dennoch in GameLoopDemo.cpp verbaut habe */
LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
static DWORD WINAPI RenderProcedure(CGameLoopDemo *pInst);
static DWORD WINAPI PollInputProcedure(CInput *pInst);

#endif // _GAMELOOPDEMO_H
